public inbox for linux-kernel@vger.kernel.org
 help / color / mirror / Atom feed
* Re: [PATCH] [KERNEL-DOC] kill warnings when building mandocs
@ 2007-04-22 23:04 Randy Dunlap
  0 siblings, 0 replies; 13+ messages in thread
From: Randy Dunlap @ 2007-04-22 23:04 UTC (permalink / raw)
  To: bbpetkov; +Cc: lkml




---
~Randy


--- Original Message ---
> On Thu, Apr 19, 2007 at 08:53:36AM -0700, Randy Dunlap wrote:
> > On Thu, 19 Apr 2007 08:20:59 +0200 Borislav Petkov wrote:
> > 
> > > <snip>
> > > > > I'm pretty sure the reason you cannot reproduce this warning is the line 
> > > > > 
> > > > > <xsl:param name="refentry.version.suppress">1</xsl:param>
> > > > > 
> > > > > which can be found in param.xsl, it being a part of the docbook-xsl
> > > > > distribution. The parameter's name is self-explanatory and a '1' suppresses
> > > > > the version generation. I was able to get this error because in the
> > > > > debian docbook-xsl package this param value is set to 0 by default.
> > > > 
> > > > Hm, I don't seem to have that file installed (except in
> > > > /usr/share/xml/docbook/stylesheet/...).  Where would it normally
> > > > be installed?
> > > 
> > > /usr/share/xml/docbook/stylesheet/nwalsh/manpages/param.xsl here
> > 
> > OK, I have that one, with a /current/ stuck in there:
> > 
> > 
> > /usr/share/xml/docbook/stylesheet/nwalsh/1.69.1/manpages/param.xsl
> > 
> > <xsl:param name="refentry.version.suppress">0</xsl:param>
> 
> That's why you don't get the warnings.
> 
> > > > > This means, some users will get this warning and some will not, depending on the
> > > > > setting in the param.xsl file. What is the way to go here wrt to a solution
> > > > > dealing with all cases:
> > > > > 
> > > > > 1. patch the kernel-doc?
> > > > > 2. issue an info so that the user can suppress the annoying warning by
> > > > > themselves?
> > > > > 3. ...?
> > > > 
> > > > 
> > > > Are other people seeing these warning messages ??
> > > Hm, is anyone building the manpages target at all?
> > 
> > Other than the 2 of us... I couldn't say.
> 
> By the way, can we consider the item 
> "- clean up Documentation/DocBook/, fix warnings that occur
> on make *docs."  
> from the KJ TODO list as now done?

i'm traveling atm  i'll check on that next week.


> > > > If so, I think that we should patch the kernel-doc.  I don't think
> > > > that many people would read info about how to avoid the warnings.
> > 
> > 
> > ---
> > ~Randy
> > *** Remember to use Documentation/SubmitChecklist when testing your code ***
> 
> -- 
> Regards/Gruß,
>     Boris.


^ permalink raw reply	[flat|nested] 13+ messages in thread
* [PATCH] [KERNEL-DOC] kill warnings when building mandocs
@ 2007-04-13  9:14 Borislav Petkov
  2007-04-13  9:29 ` Borislav Petkov
  2007-04-14 16:13 ` Randy Dunlap
  0 siblings, 2 replies; 13+ messages in thread
From: Borislav Petkov @ 2007-04-13  9:14 UTC (permalink / raw)
  To: Randy Dunlap; +Cc: lkml

This patch shuts warnings of the sort:

make -C /mnt/samsung_200/sam/kernel/trees/21-rc6/build \
	KBUILD_SRC=/mnt/samsung_200/sam/kernel/trees/21-rc6 \
	KBUILD_EXTMOD="" -f /mnt/samsung_200/sam/kernel/trees/21-rc6/Makefile mandocs
make -f /mnt/samsung_200/sam/kernel/trees/21-rc6/scripts/Makefile.build obj=scripts/basic
make -f /mnt/samsung_200/sam/kernel/trees/21-rc6/scripts/Makefile.build obj=Documentation/DocBook mandocs
  SRCTREE=/mnt/samsung_200/sam/kernel/trees/21-rc6/ /mnt/samsung_200/sam/kernel/trees/21-rc6/build/scripts/basic/docproc doc /mnt/samsung_200/sam/kernel/trees/21-rc6/Documentation/DocBook/wanbook.tmpl >Documentation/DocBook/wanbook.xml
  if grep -q refentry Documentation/DocBook/wanbook.xml; then xmlto man -m /mnt/samsung_200/sam/kernel/trees/21-rc6/Documentation/DocBook/stylesheet.xsl -o Documentation/DocBook/man Documentation/DocBook/wanbook.xml ; gzip -f Documentation/DocBook/man/*.9; fi
Note: meta version: No productnumber or alternative     sppp_close
Note: meta version: No refmiscinfo@class=version        sppp_close
Note: Writing sppp_close.9
Note: meta version: No productnumber or alternative     sppp_open
Note: meta version: No refmiscinfo@class=version        sppp_open

by adding a RefMiscInfo xml tag in the form of the current kernel version to 
the function, struct and enum definitions in files included by kernel-doc when 
building 'mandocs'.  However, the version string appears truncated on the manpage
due to some constraints in the xml DTD for the man header, I believe, for the
troff output is truncated too.


Signed-off-by: Borislav Petkov <bbpetkov@yahoo.de>

Index: 21-rc6/scripts/kernel-doc
===================================================================
--- 21-rc6.orig/scripts/kernel-doc
+++ 21-rc6/scripts/kernel-doc
@@ -326,6 +326,34 @@ while ($ARGV[0] =~ m/^-(.*)/) {
     }
 }
 
+# get kernel version
+sub get_kernel_version() {
+
+	my $version;
+	open (FILE, "../Makefile") || die "Can't open man kernel Makefile: $!";
+
+	EOF: while (my $line = <FILE>)
+	{
+		if ($line =~ /VERSION\s+=\s+(\d+)/) {
+			$version .= $1;
+			next;
+		}
+		if ($line =~ /PATCHLEVEL\s+=\s+(\d+)/) {
+			$version .= ".$1";
+			next;
+		}
+		if ($line =~ /SUBLEVEL\s+=\s+(\d+)/) {
+			$version .= ".$1";
+			next;
+		}
+		if ($line =~ /EXTRAVERSION\s+=\s+(.*)$/) {
+			$version .= $1;
+			last EOF;
+		}
+	}
+	return $version;
+}
+
 
 # generate a sequence of code that will splice in highlighting information
 # using the s// operator.
@@ -592,6 +620,7 @@ sub output_function_xml(%) {
     print "<refmeta>\n";
     print " <refentrytitle><phrase>".$args{'function'}."</phrase></refentrytitle>\n";
     print " <manvolnum>9</manvolnum>\n";
+    print " <refmiscinfo class=\"version\">" . get_kernel_version() . "</refmiscinfo>\n";
     print "</refmeta>\n";
     print "<refnamediv>\n";
     print " <refname>".$args{'function'}."</refname>\n";
@@ -668,6 +697,7 @@ sub output_struct_xml(%) {
     print "<refmeta>\n";
     print " <refentrytitle><phrase>".$args{'type'}." ".$args{'struct'}."</phrase></refentrytitle>\n";
     print " <manvolnum>9</manvolnum>\n";
+    print " <refmiscinfo class=\"version\">" . get_kernel_version() . "</refmiscinfo>\n";
     print "</refmeta>\n";
     print "<refnamediv>\n";
     print " <refname>".$args{'type'}." ".$args{'struct'}."</refname>\n";
@@ -752,6 +782,7 @@ sub output_enum_xml(%) {
     print "<refmeta>\n";
     print " <refentrytitle><phrase>enum ".$args{'enum'}."</phrase></refentrytitle>\n";
     print " <manvolnum>9</manvolnum>\n";
+    print " <refmiscinfo class=\"version\">" . get_kernel_version() . "</refmiscinfo>\n";
     print "</refmeta>\n";
     print "<refnamediv>\n";
     print " <refname>enum ".$args{'enum'}."</refname>\n";

^ permalink raw reply	[flat|nested] 13+ messages in thread

end of thread, other threads:[~2007-04-25 20:20 UTC | newest]

Thread overview: 13+ messages (download: mbox.gz follow: Atom feed
-- links below jump to the message on this page --
2007-04-22 23:04 [PATCH] [KERNEL-DOC] kill warnings when building mandocs Randy Dunlap
  -- strict thread matches above, loose matches on Subject: below --
2007-04-13  9:14 Borislav Petkov
2007-04-13  9:29 ` Borislav Petkov
2007-04-18 17:16   ` Randy Dunlap
2007-04-19  6:30     ` Borislav Petkov
2007-04-14 16:13 ` Randy Dunlap
2007-04-15  7:10   ` Borislav Petkov
2007-04-17 10:49     ` Borislav Petkov
2007-04-18 16:03       ` Randy Dunlap
2007-04-19  6:20         ` Borislav Petkov
2007-04-19 15:53           ` Randy Dunlap
2007-04-20  6:02             ` Borislav Petkov
2007-04-25 20:22               ` Randy Dunlap

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox